/*
 * Created on Jul 24, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.elements;

import diagnose.graphicengine.devices.AbstractDevice;
import diagnose.utils.geometry.Point;

/**
 * This interface have to implement each graphical element
 * drawable on GraphicArea
 */
public interface GraphicElement {
    
    /**
     * Draws element on the canvas using AbstractDevice
     * @param device
     */
    public void paint(AbstractDevice device);
    
    /**
     * @return the top-most element which can receive mouse event at point p 
     */
    public VisualElement receivesMouseEvent(Point p, AbstractDevice device);

}
