/*
 * Created on Apr 8, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.elements.system;

import diagnose.graphicengine.elements.CommonElement;
import diagnose.utils.geometry.Point;
import diagnose.utils.serialization.XmlConstants;

/**
 * Standard control point that directly changes its value
 */
public class NormalControlPointElement extends AbstractControlPointElement {
    
    /**
     * Id of controlPoint, in controled object
     */
    private int controlPointId; 

    /**
     * @param controls
     * @param controlPointId
     */
    public NormalControlPointElement(CommonElement controls, int controlPointId) {
        super(controls);
        this.controlPointId = controlPointId;
    }

    public int getControlPointId() {
        return controlPointId;
    }
    
    public void move(Point p) {
        Point target = (Point)p.clone();
        getControls().getProperties().getPointValue(XmlConstants.PROP_CP + getControlPointId()).translate(target);
    }
    
    public Point getControlPointPosition() {
        return getControls().getProperties().getPointValue(XmlConstants.PROP_CP + getControlPointId());
    }
}
