/*
 * Created on Feb 11, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.events;

import diagnose.graphicengine.Manager;
import diagnose.graphicengine.elements.CommonElement;
import diagnose.utils.Lang;

/**
 * This class handles event adding new element into document
 */
public class AddElementEvent extends PersistentEvent {

    private CommonElement elt;
    
    public AddElementEvent(Manager manager, CommonElement elt) {
        super(manager);
        this.elt = elt;
    }
    
    /* (non-Javadoc)
     * @see diagnose.graphicengine.PersistantEvent#perform()
     */
    public void perform() {
        getDocument().addElement(elt);
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.PersistantEvent#undo()
     */
    public void undo() {
        getDocument().removeElement(elt);
        getManager().clearSelectionEvent();
        /*
        if (getManager().hasSelectionElement(elt))
            getManager().removeElementFromSelectionEvent(elt);
            */
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.PersistantEvent#getDescription()
     */
    public String getDescription() {
        return Lang.get("event.addelement", elt.toString());
    }

}
