/*
 * Created on Feb 19, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.events;

import diagnose.graphicengine.Manager;
import diagnose.graphicengine.elements.implementations.GroupElement;
import diagnose.graphicengine.elements.system.Selection;
import diagnose.utils.Lang;

/**
 * Grouping event
 */
public class GroupSelectionEvent extends PersistentEvent {

    private Selection selection;
    private GroupElement grpElt; 
   
    public GroupSelectionEvent(Manager manager, Selection selection) {
        super(manager);
        this.selection = selection;
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistentEvent#perform()
     */
    public void perform() {
        grpElt = new GroupElement();       
        selection.removeFromDocument(getDocument());
        selection.pasteInto(grpElt);
        getDocument().addElement(grpElt);
        getManager().clearSelectionEvent();
        getManager().addElementToSelectionEvent(grpElt);
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistentEvent#undo()
     */
    public void undo() {
        getDocument().removeElement(grpElt);
        selection.pasteInto(getDocument());
        getManager().getRelationManager().updateRelations(selection);
        if (getManager().hasSelectionElement(grpElt)) {
            getManager().removeElementFromSelectionEvent(grpElt);
            for (int i = 0; i < selection.getElementsCount(); i++)
                getManager().addElementToSelectionEvent(selection.getElement(i));
        }
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistentEvent#getDescription()
     */
    public String getDescription() {
        return Lang.get("event.group");
    }
}
