/*
 * Created on Feb 18, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.events;

import diagnose.graphicengine.Manager;
import diagnose.graphicengine.elements.VisualElement;
import diagnose.utils.Lang;
import diagnose.utils.geometry.Point;

/**
 * Event moving element (selection)
 */
public class MoveElementEvent extends PersistentEvent {

    private Point direction;
    private VisualElement element;

    public MoveElementEvent(Manager manager, Point direction,
            VisualElement element) {
        super(manager);
        this.direction = direction;
        this.element = element;
    }
    
    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistantEvent#perform()
     */
    public void perform() {
        // moves object to specified position
        element.move(direction);
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistantEvent#undo()
     */
    public void undo() {
        element.move(new Point(-direction.x, -direction.y));
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistantEvent#getDescription()
     */
    public String getDescription() {
        return Lang.get("event.moved");
    }
}