/*
 * Created on Feb 11, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.events;

import diagnose.graphicengine.Manager;
import diagnose.graphicengine.elements.Document;

/**
 * Persistant event which influes document, so it can be done, undone and redone
 */
public abstract class PersistentEvent {
    
    private Document document;
    private Manager manager;
    
    public PersistentEvent(Manager manager) {
        this.document = manager.getDocument();
        this.manager = manager;
    }
    
    public abstract void perform();
    
    public void redo() {
        perform();
    }
    
    public abstract void undo();
    public abstract String getDescription();
    
    public Document getDocument() {
        return document;
    }

    public Manager getManager() {
        return manager;
    }
}
