/*
 * Created on Jun 18, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.events;

import diagnose.graphicengine.Manager;
import diagnose.utils.Lang;
import diagnose.utils.properties.PropertyChangeList;

/**
 * Provides change of multiple properties
 */
public class PropertiesChangeEvent extends PersistentEvent {

    private PropertyChangeList changes;
    /**
     * @param document
     */
    public PropertiesChangeEvent(Manager manager, PropertyChangeList changes) {
        super(manager);
        this.changes = changes;
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistentEvent#perform()
     */
    public void perform() {
        changes.applyChanges();
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistentEvent#undo()
     */
    public void undo() {
        changes.revertChanges();
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.events.PersistentEvent#getDescription()
     */
    public String getDescription() {
        return Lang.get("event.propertieschanged", Integer.toString(changes.size()));
    }
}
