/*
 * Created on Feb 11, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.events;

import diagnose.graphicengine.Manager;
import diagnose.graphicengine.elements.system.Selection;
import diagnose.utils.Lang;

/**
 *
 */
public class RemoveSelectionEvent extends PersistentEvent {
    
    private Selection selection;

    public RemoveSelectionEvent(Manager manager, Selection selection) {
        super(manager);
        this.selection = selection;
    }
    /* (non-Javadoc)
     * @see diagnose.graphicengine.PersistantEvent#perform()
     */
    public void perform() {
        selection.removeFromDocument(getDocument());
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.PersistantEvent#undo()
     */
    public void undo() {
        selection.pasteInto(getDocument());
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.PersistantEvent#getDescription()
     */
    public String getDescription() {
        return Lang.get("event.remove");
    }

}