/*
 * Created on Jul 14, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.libraries.scripting;

import diagnose.graphicengine.devices.AbstractDevice;
import diagnose.graphicengine.elements.CommonElement;

/**
 * Extends element factory with useful values and imports
 */
public class DefaultElementScopeFactory extends ElementScopeFactory {
    
    private static final Integer CREATION_CONTINUES = new Integer(CommonElement.CREATION_CONTINUES);
    private static final Integer CREATION_FINISHED = new Integer(CommonElement.CREATION_FINISHED);
    private static final Integer ELEMENT_NOT_VIABLE = new Integer(CommonElement.ELEMENT_NOT_VIABLE);
    private static final Integer ELEMENT_VIABLE = new Integer(CommonElement.ELEMENT_VIABLE);
    private static final Integer DEFAULT_DRAW = new Integer(AbstractDevice.DEFAULT_DRAW);
    private static final Integer USE_PADDING = new Integer(AbstractDevice.USE_PADDING);
    private static final Integer USE_ZOOM = new Integer(AbstractDevice.USE_ZOOM);
    private static final Integer IGNORE_VIEW_SETTINGS = new Integer(AbstractDevice.IGNORE_VIEW_SETTINGS);

    public DefaultElementScopeFactory(String elementID) {
        super(elementID);
        
        this.importPackage("Packages.java.util");
        this.importPackage("Packages.diagnose.graphicengine");
        this.importPackage("Packages.diagnose.graphicengine.elements.system");
        this.importPackage("Packages.diagnose.utils");
        this.importPackage("Packages.diagnose.utils.geometry");
        this.importPackage("Packages.diagnose.utils.properties");
        
        // Adds useful constants
        this.addValue("out", System.out);
        this.addValue("CREATION_CONTINUES", CREATION_CONTINUES);
        this.addValue("CREATION_FINISHED", CREATION_FINISHED);
        this.addValue("ELEMENT_NOT_VIABLE", ELEMENT_NOT_VIABLE);
        this.addValue("ELEMENT_VIABLE", ELEMENT_VIABLE);
        this.addValue("ELEMENT_VIABLE", ELEMENT_VIABLE);
        this.addValue("DEFAULT_DRAW", DEFAULT_DRAW);
        this.addValue("USE_ZOOM", USE_ZOOM);
        this.addValue("USE_PADDING", USE_PADDING);
        this.addValue("IGNORE_VIEW_SETTINGS", IGNORE_VIEW_SETTINGS);
    }

}
