/*
 * Created on Aug 8, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.relation;

import diagnose.graphicengine.elements.CommonElement;
import diagnose.graphicengine.elements.ComposedElement;
import diagnose.graphicengine.elements.Document;

/**
 * 
 */
public class RelationManager {
    
    private Document document;
    
    public RelationManager(Document document) {
        super();
        this.document = document;        
    }
    
    public void updateRelations() {
        for (int i = 0; i < document.getElementsCount(); i++)
            document.getElement(i).getRelations().clear();
        
        updateRelations(document);
    }
    
    public void updateRelations(ComposedElement group) {
            
        for (int i = 0; i < group.getElementsCount(); i++) {
            CommonElement submisive = group.getElement(i);
            if (submisive instanceof SubmissiveElement) {
                updateRelations((SubmissiveElement)submisive);
            }
        }
    }    
    
    public void updateRelations(SubmissiveElement elt) {
        clearRelationsFor(elt);
        for (int j = 0; j < document.getElementsCount(); j++) {
            elt.askDominant(document.getElement(j));
        }
    }
    
    public void clearRelationsFor(SubmissiveElement element) {
        for (int i = 0; i < document.getElementsCount(); i++)
            document.getElement(i).getRelations().clear(element);
    }
}
