/*
 * Created on Aug 8, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.graphicengine.relation;

import diagnose.graphicengine.elements.CommonElement;
import diagnose.utils.geometry.Point;

/**
 * Interface that helps to changed shared points
 *
 */
public interface SubmissiveElement {
    
    /**
     * Used by dominant element to send information about change of position of
     * point specified be id 
     */
    public void changeSubmissive(int id, Point newPosition);
    
    /**
     * Suggests dominant elements for connection at specified points
     * Lets submissive elements iterate over possible points and suggest
     * them to the dominant element  
     */
    public void askDominant(CommonElement elt);
}
