/*
 * Created on Aug 24, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.gui;

import java.awt.BorderLayout;
import java.io.IOException;
import java.net.URL;

import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JScrollPane;

import diagnose.utils.GUIUtils;
import diagnose.utils.Lang;

/**
 *
 */
public class HelpDialog extends JDialog {

    private static final long serialVersionUID = 25649067358970659L;

    public HelpDialog(String resource) {
        super();
        setTitle(Lang.get("dialog.caption.help"));
        setSize(600, 450);
        setLayout(new BorderLayout());
        GUIUtils.centerWindow(this);
        
        JEditorPane text = new JEditorPane();
        try {
            URL url = HelpDialog.class.getResource("/resources/" + resource + ".htm");
            text.setPage(url);
        } catch (IOException e) {
            e.printStackTrace();
        }
        text.setEditable(false);
        getContentPane().add(new JScrollPane(text, JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED, JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED), BorderLayout.CENTER);
        
    }

}
