/*
 * Created on Aug 7, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.gui;

import java.awt.BorderLayout;
import java.awt.Color;

import javax.swing.JFrame;
import javax.swing.JLabel;

import diagnose.utils.GUIUtils;
import diagnose.utils.IconCache;
import diagnose.utils.Lang;

/**
 *
 */
public class SplashScreen {
    
    private static JFrame form;
    private static JLabel infoLabel = new JLabel("application.title");
    private static JLabel imageLabel = new JLabel();
    
    static {
        form = new JFrame(Lang.get("application.title"));
        form.getRootPane().setLayout(new BorderLayout());
        form.setBackground(Color.WHITE);
        
        infoLabel.setForeground(Color.BLACK);
        imageLabel.setIcon(IconCache.getSystemIcon("splash01"));
        
        form.getRootPane().add(infoLabel, BorderLayout.SOUTH);
        form.getRootPane().add(imageLabel, BorderLayout.CENTER);
        form.pack();
        
        GUIUtils.centerWindow(form);
        form.setAlwaysOnTop(true);
    }
    
    public static void show() {
        form.setVisible(true);
    }
    
    public static void hide() {
        form.setVisible(false);
    }
    
    public static void setInfo(String text) {
        infoLabel.setText(text);
        form.repaint();
    }
}
