/*
 * Created on Jun 28, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.gui.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import diagnose.graphicengine.Manager;
import diagnose.gui.MainForm;

/**
 * Creates action listeners for edit menu
 */
public class EditMenuActionFactory extends MenuActionFactory {

    public EditMenuActionFactory(Manager manager, MainForm mainForm) {
        super(manager, mainForm);
    }

    public ActionListener getCopyAction() {
        return new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                getManager().copySelectionEvent();
            }};
    }
    
    public ActionListener getCutAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().cutSelectionEvent();
            }};
    }
    
    public ActionListener getPasteAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().pasteClipboardEvent();
            }};
    }
    
    public ActionListener getDeleteAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().dropSelectionEvent();
            }};
    }
    
    public ActionListener getSelectAllAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().selectAllEvent();
            }};
    }
    
    public ActionListener getSelectNoneAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().clearSelectionEvent();
            }};
    }
    
    public ActionListener getUndoAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().undo();
            }};
    }
    
    public ActionListener getRedoAction() {
        return new ActionListener()  {
            public void actionPerformed(ActionEvent e) {
                getManager().redo();
            }};
    }
}
