/*
 * Created on Jun 28, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.gui.menu;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import diagnose.graphicengine.Manager;
import diagnose.graphicengine.elements.CommonElement;
import diagnose.graphicengine.libraries.DependencyException;
import diagnose.gui.MainForm;
import diagnose.utils.GUIUtils;
import diagnose.utils.Lang;
import diagnose.utils.Log;

/**
 * Creates action for insert menu
 */
public class InsertMenuActionFactory extends MenuActionFactory {

    public InsertMenuActionFactory(Manager manager, MainForm mainForm) {
        super(manager, mainForm);
    }
    
    public ActionListener getObjectCreateAction(final Class objectClass) {
        return new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                try {
                    getManager().setupCreatingObject((CommonElement)objectClass.newInstance());
                } catch (Exception ex) {
                    Log.error(Lang.get("log.unabletocreateelement"));
                }
            }
        };
    }
    
    public ActionListener getLibElementCreateAction(final String libName, final String eltName) {
        return new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                try {
                    getManager().setupCreatingLibraryObject(libName, eltName);
                } catch (DependencyException e1) {
                    unableToInsertElement(getMainForm(), libName, eltName, e1.getDependencies());
                }
            }};
    }
    
    public static void unableToInsertElement(JFrame parentFrame, String libName, 
                                                String eltName, ArrayList dependencies) {
        JOptionPane.showMessageDialog(parentFrame, 
                Lang.get("msg.missingelementsforelement", 
                        new String [] {eltName, libName,
                        GUIUtils.getListOfMissingDependencies(dependencies)}), 
                Lang.get("msg.caption.problem"), JOptionPane.ERROR_MESSAGE);
        
    }
}
