/*
 * Created on Jun 3, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.gui.properties;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import diagnose.utils.Lang;
import diagnose.utils.properties.Property;
import diagnose.utils.properties.PropertyChangeLog;
import diagnose.utils.properties.PropertyDescription;

/**
 *
 */
public class ColorPropertyBox extends PropertyBox {
    
    private JButton colorBtn = new JButton();
    
    /**
     * @param description
     * @param property
     */
    public ColorPropertyBox(PropertyDescription description, Property property, String invalidMessage) {
        super(description, property, invalidMessage);
    }

    /* (non-Javadoc)
     * @see diagnose.gui.properties.PropertyBox#validate()
     */
    public boolean validate() {
        return true;
    }

    /* (non-Javadoc)
     * @see diagnose.gui.properties.PropertyBox#getComponent()
     */
    public JComponent getComponent() {
        JPanel panel = new JPanel();
        panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
        panel.setAlignmentX(Component.LEFT_ALIGNMENT);
        
        JLabel lbl = ComponentFactory.createLabel(getDescription().getDescription());
        panel.add(lbl);

        Color cx = (Color)getProperty().getValue();
        final Color c = (cx == null ? Color.LIGHT_GRAY : cx);
        colorBtn.setBackground(c);
        colorBtn.setAlignmentX(Component.LEFT_ALIGNMENT);
        
        colorBtn.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e) {
                Color cx = JColorChooser.showDialog(null, Lang.get("dialog.caption.pickacolor"), c);
                if (cx != null) {
                    colorBtn.setBackground(cx);
                    setChanged(true);
                }
            }});
        
        colorBtn.setEnabled(!getDescription().isReadOnly());
        colorBtn.setAlignmentX(Component.LEFT_ALIGNMENT);
        panel.add(colorBtn);
        return panel;
    }

    /* (non-Javadoc)
     * @see diagnose.gui.properties.PropertyBox#saveValues()
     */
    public PropertyChangeLog saveValues() {
        return (isChanged() ? new PropertyChangeLog(getProperty(), colorBtn.getBackground()) : null); 
    }
}
