/*
 * Created on Aug 9, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.gui.properties;

import java.awt.Component;

import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;

/**
 * Creates standardized components for properties
 */
public class ComponentFactory {
    
    public static JLabel createLabel(String caption) {
        JLabel result = new JLabel(caption);
        setDefaultProperties(result);
        return result;
    }
    
    public static JCheckBox createCheckBox(String caption) {
        JCheckBox result = new JCheckBox(caption);
        result.setBorder(BorderFactory.createEmptyBorder(8, 8, 8, 8));
        result.setAlignmentX(Component.LEFT_ALIGNMENT);
        return result;
    }
    
    public static void setDefaultProperties(JComponent component) {
        component.setBorder(BorderFactory.createEmptyBorder(8, 8, 8, 8));
        component.setAlignmentX(Component.LEFT_ALIGNMENT);
    }
}
