/*
 * Created on Jul 28, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils;

import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.net.URL;
import java.util.HashMap;

import diagnose.gui.menu.MenuFactory;

/**
 * Creates cursors
 */
public class CursorFactory {
    
    private static HashMap cache = new HashMap();
    
    public static Cursor getDefaultCursor() {
        return Cursor.getDefaultCursor();
    }
    
    public static Cursor getWaitCursor() {
        return Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);
    }
    
    public static Cursor getInsertPointCursor() {
        return Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR);
    }
    
    public static Cursor getCursor(String name) {
        return (Cursor)cache.get(name);
    }
    
    public static void createCursor(String imageName, Point hotspot) {
        
        URL imageURL = MenuFactory.class.getResource("/resources/" + imageName + ".png");
        if (imageURL != null) {
            Image img = Toolkit.getDefaultToolkit().createImage(imageURL);
            cache.put(imageName, Toolkit.getDefaultToolkit().createCustomCursor(img, hotspot, imageName));
        }
    }
}
