/*
 * Created on Jun 29, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils;

import java.awt.Toolkit;

import diagnose.utils.geometry.Point;

/**
 * Utils for converting pixels to other units
 */
public class DPIUtils {

    private static final double DPI = Toolkit.getDefaultToolkit().getScreenResolution();
    
    /** contains information about howmany pixels has each milimeters */
    private static final double milimiter = DPI / 25.4d;
    
    public static double pixelsToMilimeters(double px) {
        return px / milimiter; 
    }
    
    public static double milimetersToPixels(double mm) {
        return mm * milimiter; 
    }
    
    public static Point pixelsToMilimeters(Point px) {
        Point p = (Point)px.clone();
        p.x /= milimiter;
        p.y /= milimiter;
        return p;
    }
    
    public static Point milimetersToPixels(Point mm) {
        Point p = (Point)mm.clone();
        p.x *= milimiter;
        p.y *= milimiter;
        return p;
    }
    
    public static Point pixelsToMilimeters(java.awt.Point px) {
        return pixelsToMilimeters(new Point(px));
    }
    
    public static Point milimetersToPixels(java.awt.Point mm) {
        return milimetersToPixels(new Point(mm));
    }
}