/*
 * Created on Jul 19, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils;

import java.awt.GraphicsEnvironment;

import diagnose.graphicengine.devices.AbstractDevice;
import diagnose.utils.properties.SelectPropertyDescription;

/**
 * Fills arrays with standard values
 */
public class DefaultArrays {

    
    public static String [] fontList = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
    
    /**
     * Fills property descriptor with default line styles
     */
    public static void fillLineStyles(SelectPropertyDescription lineStyleDesc) {
        lineStyleDesc.addItem(Integer.toString(AbstractDevice.CLEAR_LINE), "@/resources/lineclear.png");
        lineStyleDesc.addItem(Integer.toString(AbstractDevice.POINT_LINE), "@/resources/linepoints.png");
        lineStyleDesc.addItem(Integer.toString(AbstractDevice.DASH_LINE), "@/resources/linedash.png");
        lineStyleDesc.addItem(Integer.toString(AbstractDevice.DASH_POINT_LINE), "@/resources/linedashpoint.png");
    }
    
    /**
     * Fills property descriptor with fonts
     */
    public static void fillFontNames(SelectPropertyDescription fontDesc) {
        for (int i = 0; i < fontList.length; i++)
            fontDesc.addItem(fontList[i], fontList[i]);
    }

}
