/*
 * Created on Jul 19, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils;

import java.net.URL;
import java.util.HashMap;

import javax.swing.Icon;
import javax.swing.ImageIcon;

import diagnose.gui.menu.MenuFactory;

/**
 * Caches icons from resources into memory
 */
public class IconCache {
    
    private static HashMap cache = new HashMap();

    /**
     * Loads icon form system resources
     */
    public static Icon getSystemIcon(String iconName) {
        return getIcon("/resources/" + iconName + ".png");
    }
    
    /**
     * Load icons and puts it into cache
     */
    public static Icon getIcon(String iconPath) {
        String imgLocation = iconPath;
        
        Icon ico = (Icon)cache.get(iconPath);
        if (ico != null) return ico;
        
        URL imageURL = MenuFactory.class.getResource(imgLocation);
        if (imageURL != null) {
            Icon icon = new ImageIcon(imageURL);
            cache.put(iconPath, icon);
            return icon;
        }
        
        Log.error(Lang.get("log.unabletoloadimage", imgLocation));
        return null;
    }
}
