/*
 * Created on Feb 10, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils;

/**
 * Logs system informations
 */
public class Log {
    
    public static final int DEBUG = -1;
    public static final int INFO = 0;
    public static final int WARNING = 1;
    public static final int ERROR = 2;
    
    public static void info(String message) {
        log(INFO, message);
    }
    
    public static void warn(String message) {
        log(WARNING, message);
    }
    
    public static void error(String message) {
        log(ERROR, message);
    }
    
    public static void debug(String message) {
        log(DEBUG, message);
    }
    
    private static void log(int level, String message) {
        if (level == DEBUG) writeOut("DEBUG: " + message);
        if (level == INFO) writeOut("INFO: " + message);
        if (level == WARNING) writeOut("WARN: " + message);
        if (level == ERROR) writeOut("ERROR: " + message);
    }
    
    private static void writeOut(String msg) {
        System.out.println(msg);
    }
}
