/**
 * Represents abscissa
 */


package diagnose.utils.geometry;




public class Abscissa
{
	protected double lineX1;
	protected double lineY1;
	protected double lineX2;
	protected double lineY2;

	/**
	 * creates line which is specified by two points
	 */
	public Abscissa(Point p1, Point p2)
	{
	    lineX1 = p1.x;
	    lineX2 = p2.x;

	    lineY1 = p1.y;
	    lineY2 = p2.y;
	}
	
	/**
	 * @return distance between line and point
	 */
	public double getDistance(Point p)
	{
		double distance;
		Line l = new Line(new Point(lineX1, lineY1), new Point(lineX2, lineY2));
		double dist0 = l.getDistance(p);
		double dist1 = p.distance(lineX1, lineY1);
		double dist2 = p.distance(lineX2, lineY2);
		distance = Math.min(dist0, Math.min(dist1, dist2));
		return distance;
	}
	
	public Point getNearestPoint(Point p)
	{
		Point result = new Point();
        
        double u1 = lineX2 - lineX1;
        double u2 = lineY2 - lineY1;
        
        double a1 = lineX1;
        double a2 = lineY1;
        double c1 = p.x;
        double c2 = p.y;
        double t = - (u1 * (a1 - c1) + u2 * (a2 - c2)) / (Math.pow(u1, 2) + Math.pow(u2, 2));

        if ((t >= 0 ) && (t <= 1)) {
            result.x = (u1 * t + lineX1);
            result.y = (u2 * t + lineY1);
            return result;
        } else {
            double distance1 = p.distance(lineX1, lineY1);
            double distance2 = p.distance(lineX2, lineY2);
            
            if (distance1 < distance2) return new Point(lineX1, lineY1);
            else return new Point(lineX2, lineY2);
        }
       
	}
}
