/*
 * Created on Oct 15, 2004
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.geometry;

import java.awt.geom.Line2D;


/**
 * Contains "useful" functions for geometrical calculations
 */
public class Geometry {
    
    /**
     * @return true if point <code>p</code> lies on absicca specifed by
     * points <code>p1, p2</code>, otherwise false
     */
    public static boolean isOnLine(Point p1, Point p2, Point p, double precissness) {
        
        double dist = Line2D.ptSegDist(p1.x, p1.y, p2.x, p2.y, p.x, p.y);
        if (dist < precissness) return true;
        return false;
    }
    
    /**
     * @return scaled point <code>p</code> using given <code>center</code>
     * scaling factor
     */
    public static Point scale(Point p, Point center, Point coef) {
        
        Point result = new Point();
        
        double px = p.x - center.x;
        double py = p.y - center.y;
        
        result.x = (coef.x != 0 ? px * coef.x + center.x : p.x);
        result.y = (coef.y != 0 ? py * coef.y + center.y : p.y);
        
        return result;
    }
}
