/**
 * Represents line
 */


package diagnose.utils.geometry;

import java.awt.geom.Line2D;



public class Line
{
	protected double a;
	protected double b;
	protected double c;
    
    protected double lineX1;
    protected double lineY1;
    protected double lineX2;
    protected double lineY2;

	/**
	 * creates line which is specified by two points
	 */
	public Line(Point p1, Point p2)
	{
	    double vectorX = p2.x - p1.x;
	    double vectorY = p2.y - p1.y;
		this.a = vectorY;
		this.b = -vectorX;
		this.c = (p1.y * vectorX - p1.x * vectorY);
        lineX1 = p1.x;
        lineY1 = p1.y;
        lineX2 = p2.x;
        lineY2 = p2.y; 
	}
	
	/**
	 * @return distance between line and point
	 */
	public double getDistance(Point p)
	{
        return Line2D.ptLineDist(lineX1, lineY1, lineX2, lineY2, p.x, p.y);
		//return ((Math.abs((a * p.x + b * p.y + c)) / Math.sqrt((Math.pow(p.x, 2) + Math.pow(p.y, 2)))));
	}
	
	public Point getNearestPoint(Point p)
	{
        
		Point result = new Point();

		double u1 = lineX2 - lineX1;
		double u2 = lineY2 - lineY1;
        
        double s = - (u2 * (lineY1 - p.y) + u1 * (lineX1 - p.x)) / ((Math.pow(u1, 2) + Math.pow(u2, 2)));
                    
        result.x = (u1 * s + lineX1);
        result.y = (u2 * s + lineY1);
        
		return result;
	}
}
