/*
 * Created on Apr 8, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.geometry;


/**
 * Represents point
 */
public class Point implements Cloneable {

    public double x = 0;
    public double y = 0;
    
    public Point() { 
        super();
    }
    
    public Point(double x, double y) {
        super();
        this.x = x;
        this.y = y;
    }
    
    public Point(java.awt.Point p) {
        super();
        this.x = p.x;
        this.y = p.y;
    }
    
    public void translate(double x, double y) {
        this.x += x;
        this.y += y;
    }
    
    public void translate(Point p) {
        this.x += p.x;
        this.y += p.y;
    }
    
    public double distance(double x, double y) {
        return Math.sqrt(sqr(this.x - x) + sqr(this.y - y)); 
    }
    
    public double distance(Point p) {
        return Math.sqrt(sqr(this.x - p.x) + sqr(this.y - p.y)); 
    }
    
    public void multiply(double s) {
        this.x *= s;
        this.y *= s;
    }
    
    public Object clone() {
        return new Point(x, y);
    }
    
    private static double sqr(double x) {
        return x * x;
    }
    
    public boolean equals(Object o) {
        if (o instanceof Point) {
            Point op = (Point)o;
            return ((op.x == this.x) && (op.y == this.y));
        }
        return super.equals(o);
    }
    
    public String toString() {
        return "[ Point: " + x + "; " + y + " ]";
    }
    
    public int hashCode() {
        long bits = java.lang.Double.doubleToLongBits(x);
        bits ^= java.lang.Double.doubleToLongBits(y) * 31;
        return (((int) bits) ^ ((int) (bits >> 32)));
    }
}