/*
 * Created on Apr 23, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import org.jdom.Element;

import diagnose.utils.serialization.DeserializationException;
import diagnose.utils.serialization.Deserializer;
import diagnose.utils.serialization.XmlConstants;

/**
 *
 */
public class BoolProperty extends Property {

    public BoolProperty() {
        super();
        this.value = new Boolean(false);
    }

    /**
     * @param name
     * @param accessibility
     */
    public BoolProperty(String name, boolean value) {
        super(name);
        this.value = new Boolean(value);
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.properties.Property#cloneValue()
     */
    protected Object cloneValue() {
        return new Boolean(((Boolean)value).booleanValue());
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.serialization.XMLSeriazable#getElementType()
     */
    public String getElementType() {
        return XmlConstants.ELEMENT_BOOL_PROPERTY;
    }
    
    public void deserialize(Element elt, Deserializer deserializer) throws DeserializationException {
        super.deserialize(elt, deserializer);
        value = new Boolean(elt.getAttributeValue(XmlConstants.VALUE));
    }
    
    public Element serialize() {
        Element e = super.serialize();
        if (e != null) e.setAttribute(XmlConstants.VALUE, ((Boolean)value).booleanValue() ? XmlConstants.TRUE : XmlConstants.FALSE);
        return e;
    }
}