/*
 * Created on Jun 3, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import java.awt.Color;

import org.jdom.Element;

import diagnose.utils.serialization.DeserializationException;
import diagnose.utils.serialization.Deserializer;
import diagnose.utils.serialization.XmlConstants;

/**
 * 
 */
public class ColorProperty extends Property {
    
    public ColorProperty() {
        super();
        this.value = Color.BLACK;
    }

    /**
     * @param name
     * @param accessibility
     */
    public ColorProperty(String name, Color value) {
        super(name);
        this.value = value;
    }

    protected Object cloneValue() {
        return new Color(((Color)getValue()).getRGB());
    }

    public String getElementType() {
        return XmlConstants.ELEMENT_COLOR_PROPERTY;
    }
    
    public void deserialize(Element elt, Deserializer deserializer) throws DeserializationException {
        super.deserialize(elt, deserializer);
        value = new Color(Integer.parseInt(elt.getAttributeValue(XmlConstants.VALUE), 16));
    }
    
    public Element serialize() {
        Element e = super.serialize();
        if (e != null) e.setAttribute(XmlConstants.VALUE, Integer.toHexString((((Color)value).getRGB())).substring(2));
        return e;
    }


}
