/*
 * Created on Apr 21, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import org.jdom.Element;

import diagnose.utils.serialization.DeserializationException;
import diagnose.utils.serialization.Deserializer;
import diagnose.utils.serialization.XmlConstants;

/**
 * 
 */
public class DoubleProperty extends Property {

    public DoubleProperty() {
        super();
        this.value = new Double(0);
    }

    /**
     * @param name
     * @param accessibility
     */
    public DoubleProperty(String name, double value) {
        super(name);
        this.value = new Double(value);
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.properties.Property#cloneValue()
     */
    protected Object cloneValue() {
        return new Double(((Double)value).doubleValue());
    }
    
    public Element serialize() {
        Element e = super.serialize();
        if (e != null) e.setAttribute(XmlConstants.VALUE, value.toString());
        return e;
    }
    
    public void deserialize(Element elt, Deserializer deserializer) throws DeserializationException {
        super.deserialize(elt, deserializer);
        value = new Double(Double.parseDouble(elt.getAttributeValue(XmlConstants.VALUE)));
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.XMLSeriazable#getElementType()
     */
    public String getElementType() {
        return XmlConstants.ELEMENT_DOUBLE_PROPERTY;
    }
}