/*
 * Created on Feb 11, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import org.jdom.Element;

import diagnose.utils.serialization.DeserializationException;
import diagnose.utils.serialization.Deserializer;
import diagnose.utils.serialization.XmlConstants;

/**
 * 
 */
public class IntProperty extends Property {
    
    public IntProperty() {
        super();
        this.value = new Integer(0);
    }
    
    public IntProperty(String name, int value) {
        super(name);
        this.value = new Integer(value);
    }

    public Element serialize() {
        Element e = super.serialize();
        if (e != null) e.setAttribute(XmlConstants.VALUE, value.toString());
        return e;
    }
    
    public void deserialize(Element elt, Deserializer deserializer) throws DeserializationException {
        super.deserialize(elt, deserializer);
        value = new Integer(Integer.parseInt(elt.getAttributeValue(XmlConstants.VALUE)));
    }

    /* (non-Javadoc)
     * @see diagnose.graphicengine.properties.Property#cloneValue()
     */
    protected Object cloneValue() {
        return new Integer(((Integer)value).intValue());
    }
    
    /* (non-Javadoc)
     * @see diagnose.graphicengine.XMLSeriazable#getElementType()
     */
    public String getElementType() {
        return XmlConstants.ELEMENT_INT_PROPERTY;
    }
}
