/*
 * Created on Jul 14, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import org.jdom.CDATA;
import org.jdom.Content;
import org.jdom.Element;

import diagnose.utils.serialization.DeserializationException;
import diagnose.utils.serialization.Deserializer;
import diagnose.utils.serialization.XmlConstants;

/**
 * Represents exectuable code
 */
public class MethodProperty extends Property {

    public MethodProperty() {
        super();
        this.value = "";
    }

    public MethodProperty(String name, Object value) {
        super(name, value);
        this.value = value;
    }
    
    public void deserialize(Element elt, Deserializer deserializer) throws DeserializationException {
        super.deserialize(elt, deserializer);
        if (elt.getContent().size() > 0) {
            Content cnt = (Content)elt.getContent().get(0);
            if (elt.getContent().size() > 0) value = ((CDATA)cnt).getText();
            else value = elt.getAttributeValue(XmlConstants.VALUE);
        } else value = "";
    }
    
    public Element serialize() {
        Element e = super.serialize();
        if (e != null) e.addContent(builder.cdata((String)value));
        return e;
    }
    
    protected Object cloneValue() {
        return new String((String)value);
    }

    public String getElementType() {
        return XmlConstants.ELEMENT_METHOD_PROPERTY;
    }
}
