/*
 * Created on Jun 18, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import java.util.ArrayList;

/**
 * Holds informations about change of multiple properties
 */
public class PropertyChangeList {
    
    protected ArrayList list = new ArrayList();
    
    public PropertyChangeList() {
        super();
    }
    
    public void add(PropertyChangeLog propertyChangeLog) {
        list.add(propertyChangeLog);
    }
    
    public void add(PropertyChangeList propertyChangeList) {
        list.addAll(propertyChangeList.list);
    }
    
    public int size() {
        return list.size();
    }
    
    public PropertyChangeLog get(int index) {
        return (PropertyChangeLog)list.get(index);
    }
    
    public void applyChanges() {
        for (int i = 0; i < list.size(); i++)
            ((PropertyChangeLog)list.get(i)).applyChanges();
    }
    
    public void revertChanges() {
        for (int i = 0; i < list.size(); i++)
            ((PropertyChangeLog)list.get(i)).revertChanges();
    }

}
