/*
 * Created on Apr 28, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.properties;

import java.util.HashMap;

import org.jdom.Element;

import diagnose.utils.serialization.DeserializationException;
import diagnose.utils.serialization.Deserializer;
import diagnose.utils.serialization.Serializer;
import diagnose.utils.serialization.XMLSeriazable;
import diagnose.utils.serialization.XmlConstants;

/**
 *
 */
public class PropertyDescriptor implements XMLSeriazable {
    
    protected HashMap descriptions = new HashMap();
    
    public PropertyDescriptor() {
        super();
    }
    
    public void setDescription(String propertyName, String description, String category, int position) {
        setDescription(new PropertyDescription(propertyName, description, category, position));
    }
    
    public void setDescription(String propertyName, String description, String category, int position, boolean readOnly) {
        setDescription(new PropertyDescription(propertyName, description, category, position, readOnly));
    }
    
    public void setDescription(PropertyDescription desc) {
        descriptions.put(desc.getPropertyName(), desc);
    }
    
    public PropertyDescription getDescription(String name) {
        return (PropertyDescription)descriptions.get(name);
    }

    public Element serialize() {
        return Serializer.serializeCollection(getElementType(), descriptions.values());
    }

    public void deserialize(Element elt, Deserializer deserializer) throws DeserializationException {
        for (int i = 0; i < elt.getChildren().size(); i++)
            setDescription((PropertyDescription)deserializer.deserialize((Element)elt.getChildren().get(i)));
    }
    
    public int getItemsCount() {
        return descriptions.size();
    }

    public String getElementType() {
        return XmlConstants.ELEMENT_PROPERTY_DESCRIPTOR;
    }
}