/*
 * Created on Apr 15, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.serialization;

import org.jdom.DefaultJDOMFactory;
import org.jdom.Element;



/**
 * Interface for serializanig elements into XML file
 */
public interface XMLSeriazable {
    /**
     * Builder for creating elements
     */
    static final DefaultJDOMFactory builder = new DefaultJDOMFactory();
    
    /**
     * @return serialiazed object as JDOM element
     */
    Element serialize();
    
    /**
     * @return reconstruct (fills) element with informations from element <code>elt</code> 
     * @param elt - JDOM Element
     * @param deserializer - deserialiazer that can be used to deserialize inner elements
     */
    void deserialize(Element elt, Deserializer deserializer) throws DeserializationException;
    
    /**
     * @return element name that will represent serialiazed element in documents
     * e.g. line, document, group, etc.
     */
    String getElementType();
}
