/*
 * Created on Jul 26, 2005
 *
 * (c) Petr Krajca <pkrajca@iol.cz>
 */

package diagnose.utils.serialization;

/**
 * Contains all constants for elements and attributes
 * for serialisation/deserialization
 *
 */
public interface XmlConstants {
    
    public static final String POINT_X  = "x";
    public static final String POINT_Y  = "y";
    public static final String VALUE    = "value";
    public static final String ITEM     = "item";
    public static final String TRUE     = "true";
    public static final String FALSE    = "false";
    
    public static final String NAME     = "name";
    
    public static final String ELEMENT_POINT_PROPERTY   = "point";
    public static final String ELEMENT_BOOL_PROPERTY    = "bool";
    public static final String ELEMENT_COLOR_PROPERTY   = "color";
    public static final String ELEMENT_DOUBLE_PROPERTY  = "double";
    public static final String ELEMENT_INT_PROPERTY     = "int";
    public static final String ELEMENT_METHOD_PROPERTY  = "method";
    public static final String ELEMENT_STRING_PROPERTY  = "string";
    public static final String ELEMENT_PROPERTIES       = "properties";
    public static final String ELEMENT_PROPERTY_DESCRIPTION = "propertyDescription";
    public static final String ELEMENT_PROPERTY_DESCRIPTOR = "propertyDescriptor";
    public static final String ELEMENT_SELECT_PROPERTY_DESCRIPTOR = "selPropertyDescription";
    public static final String ELEMENT_LINE = "line";
    public static final String ELEMENT_POLYLINE = "polyline";
    public static final String ELEMENT_RECT = "rect";
    public static final String ELEMENT_ELLIPSE = "ellipse";
    public static final String ELEMENT_DOCUMENT = "document";
    public static final String ELEMENT_GROUP = "group";
    public static final String ELEMENT_TEXT = "text";
    public static final String ELEMENT_POINT_BASED = "pointBased";
    public static final String ELEMENT_RECT_BASED = "rectBased";
    public static final String ELEMENT_ACTIVE = "active";
    public static final String ELEMENT_POLYGON = "polygon";
    public static final String ELEMENT_LIB_CONFIG = "libConfig";
    public static final String ELEMENT_LIBRARY = "library";
    public static final String ELEMENT_LIBRARY_ELEMENT = "libElement";
    public static final String ELEMENT_GUIDE_LINE = "guideLine";
    public static final String ELEMENT_GUIDE_LINES = "guideLines";
    public static final String ELEMENT_PATH = "path";
    public static final String ELEMENT_ARROW = "arrow";
    
    public static final String PROPDESC_NAME        = "name";
    public static final String PROPDESC_READONLY    = "readOnly";
    public static final String PROPDESC_POSITION    = "position";
    public static final String PROPDESC_CATEGORY    = "category";
    public static final String PROPDESC_DESCRIPTION = "desc";
    
    public static final String PROP_SHOW_GRID = "showGrid";
    public static final String PROP_SHOW_GUIDELINES = "showGuideLines";
    public static final String PROP_GRID_SIZE = "gridsize";
    public static final String PROP_COLOR   = "color";
    public static final String PROP_BACKGROUND  = "background";
    public static final String PROP_LINE_WIDTH  = "lineWidth";
    public static final String PROP_LINE_STYLE  = "lineStyle";
    public static final String PROP_ALIGN   = "align";
    public static final String PROP_FONT_FACE   = "fontFace";
    public static final String PROP_FONT_SIZE   = "fontSize";
    public static final String PROP_BOLD    = "bold";
    public static final String PROP_ITALIC  = "italic";
    public static final String PROP_UNDERLINE   = "underline";
    public static final String PROP_SNAP_TO_GRID    = "snapToGrid";
    public static final String PROP_PADDING = "padding";
    public static final String PROP_ZOOM    = "zoom";
    public static final String PROP_CP_COUNT = "ControlPointCount";
    public static final String PROP_CP_0 = "ControlPoint0";
    public static final String PROP_CP_1 = "ControlPoint1";
    public static final String PROP_CP  = "ControlPoint";
    public static final String PROP_URL = "url";
    public static final String PROP_NAME = "name";
    public static final String PROP_WIDTH = "width";
    public static final String PROP_HEIGHT = "height";
    public static final String PROP_POSITION = "position";
    public static final String PROP_TRANSPARENT = "transparent";
    public static final String PROP_LIBRARY = "library";
    public static final String PROP_DESCRIPTION = "desc";
    public static final String PROP_TEXT = "text";
    public static final String PROP_ZINDEX = "zindex";
    public static final String PROP_ACTIVE_CONTENT = "activeContent";
    public static final String PROP_ORIENTATION = "orientation";
    public static final String PROP_SNAP_TO_GUIDELINES = "snapGuideLines";
    public static final String PROP_SNAP_TO_OTHER_ELEMENT = "snapElements";
    public static final String PROP_SNAP_TECH = "snapTech";
    public static final String PROP_PARENT = "parent";
    public static final String PROP_END1 = "end1";
    public static final String PROP_END2 = "end2";
    public static final String PROP_TEXTCOLOR = "textColor";
    
    public static final String METHOD_CANCEL_CREATION = "cancelCreation";
    public static final String METHOD_PAINT = "paint";
    public static final String METHOD_MOVE = "move";
    public static final String METHOD_SCALE = "scale";
    public static final String METHOD_SNAPS = "snaps";
    public static final String METHOD_GET_RECT_BOUNDS = "getRectBounds";
    public static final String METHOD_RECEIVE_MOUSE_EVENT = "receivesMouseEvent";
    public static final String METHOD_GET_CONTROL_POINT_ELEMENTS = "getControlPointElements";
    public static final String METHOD_GET_SNAPABLE_POINTS = "getSnapablePoints";
    public static final String METHOD_FIXATE_LAST_CONTROL_POINT = "fixateLastControlPoint";
    public static final String METHOD_INIT = "init";
    public static final String METHOD_ASK_DOMINANT = "askDominant";
    public static final String METHOD_CHANGE_SUBMISSIVE = "changeSubmissive";
    public static final String METHOD_SUGGEST_RELATION = "suggestRelation";
    
    public static final String LANG_ITEM_NAME = "name";
}